Bug 1961783 - Review Request: rofimoji - A character picker for rofi
Summary: Review Request: rofimoji - A character picker for rofi
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Ben Beasley
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1964027
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-05-18 16:58 UTC by Major Hayden 🤠
Modified: 2021-06-11 01:19 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-06-03 15:54:50 UTC
Type: ---
Embargoed:
code: fedora-review+


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Bugzilla 1964027 1 medium CLOSED Review Request: wtype - xdotool type for Wayland 2021-05-25 14:09:40 UTC

Internal Links: 1964027

Description Major Hayden 🤠 2021-05-18 16:58:38 UTC
Spec URL: https://github.com/major/rpms/blob/main/rofimoji.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/mhayden/packages/fedora-rawhide-x86_64/02185143-rofimoji/rofimoji-5.1.0-2.fc35.src.rpm
Description: A character picker for rofi
Fedora Account System Username: mhayden

Comment 1 Ben Beasley 2021-05-21 12:35:53 UTC
Fixed the issue title.

Please link to the “raw” spec file so that tools such as fedora-review can process it:

Spec URL: https://raw.githubusercontent.com/major/rpms/main/rofimoji.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/mhayden/packages/fedora-rawhide-x86_64/02185143-rofimoji/rofimoji-5.1.0-2.fc35.src.rpm

Comment 2 Ben Beasley 2021-05-21 13:15:58 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== Issues =====

- Rpmlint reports:

    python3-rofimoji.noarch: E: non-executable-script /usr/lib/python3.9/site-packages/picker/rofimoji.py 644 /usr/bin/env python3

  You can remove the shebang line in %prep:

    # No need for this to be a script when installed in site-packages:
    sed -r -i 's/1{/^#!/d}/' picker/rofimoji.py

  The entry point via /usr/bin/rofimoji will still work, of course.

- By default (installed in a clean mock chroot) the roflmoji command fails with

    Could not find a valid way to type characters. Please check the required dependencies.

  To support both Wayland and X11 sessions, it seems that rofimoji should have:

    # X11
    Requires:       rofi
    Requires:       xsel
    Requires:       xclip
    Requires:       xdotool

    # Wayland
    Requires:       wofi
    # For wl-copy
    Requires:       wl-clipboard
    Requires:       wtype

  You might argue that these should all be weak dependencies
  (https://docs.fedoraproject.org/en-US/packaging-guidelines/WeakDependencies/),
  but I think that this is not appropriate since rofimoji will not function at
  all without the appropriate group of dependencies for the session.

- Since wtype is needed for this package to work with Wayland sessions, you
  should package it first. It is a very simple package, and I will be happy to
  review it as well, and to answer questions about packaging it.

    https://github.com/atx/wtype

- The spec file in the SRPM is (trivially) different from the one in the spec
  file link.

- The pattern for the man page should allow for the compression format to
  change. Change this:

    %{_mandir}/man1/%{name}.1.gz

  to this:

    %{_mandir}/man1/%{name}.1*

  See https://docs.fedoraproject.org/en-US/packaging-guidelines/#_manpages.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License", "*No copyright* Expat
     License". 314 files have unknown license. Detailed output of
     licensecheck in /home/reviewer/1961783-rofimoji/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Package functions as described.

     See Issues section; some dependencies are needed.

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: python3-rofimoji-5.1.0-2.fc35.noarch.rpm
          rofimoji-5.1.0-2.fc35.src.rpm
python3-rofimoji.noarch: W: spelling-error %description -l en_US emoji -> emotive
python3-rofimoji.noarch: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
python3-rofimoji.noarch: W: spelling-error %description -l en_US wofi -> woof
python3-rofimoji.noarch: E: non-executable-script /usr/lib/python3.9/site-packages/picker/rofimoji.py 644 /usr/bin/env python3
rofimoji.src: W: spelling-error Summary(en_US) rofi -> profit
rofimoji.src: W: spelling-error %description -l en_US emoji -> emotive
rofimoji.src: W: spelling-error %description -l en_US rofi -> profit
rofimoji.src: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
rofimoji.src: W: spelling-error %description -l en_US wofi -> woof
2 packages and 0 specfiles checked; 1 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
python3-rofimoji.noarch: W: spelling-error %description -l en_US emoji -> emotive
python3-rofimoji.noarch: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
python3-rofimoji.noarch: W: spelling-error %description -l en_US wofi -> woof
python3-rofimoji.noarch: E: non-executable-script /usr/lib/python3.9/site-packages/picker/rofimoji.py 644 /usr/bin/env python3
1 packages and 0 specfiles checked; 1 errors, 3 warnings.



Source checksums
----------------
https://github.com/fdw/rofimoji/archive/5.1.0/rofimoji-5.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : fba77f79c131f9423e0e92c22cd288c903f202ee46e8512740b732cc8df03f2d
  CHECKSUM(SHA256) upstream package : fba77f79c131f9423e0e92c22cd288c903f202ee46e8512740b732cc8df03f2d


Requires
--------
python3-rofimoji (rpmlib, GLIBC filtered):
    (python3.9dist(configargparse) < 2 with python3.9dist(configargparse) > 0.15)
    /usr/bin/python3
    python(abi)
    python3.9dist(setuptools)
    rofi



Provides
--------
python3-rofimoji:
    python-rofimoji
    python3-rofimoji
    python3.9-rofimoji
    python3.9dist(rofimoji)
    python3dist(rofimoji)



Diff spec file in url and in SRPM
---------------------------------
--- /home/reviewer/1961783-rofimoji/srpm/rofimoji.spec	2021-05-21 08:36:58.634283648 -0400
+++ /home/reviewer/1961783-rofimoji/srpm-unpacked/rofimoji.spec	2021-05-14 09:22:32.000000000 -0400
@@ -41,4 +41,5 @@
 %py3_install
 
+# Note that there is no %%files section for the unversioned python module
 %files -n python3-%{srcname}
 %license LICENSE
@@ -54,3 +55,3 @@
 
 * Fri May 14 2021 Major Hayden <major> - 5.1.0-1
-- Initial build.
+- Initial build.
\ No newline at end of file


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 1961783
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Python
Disabled plugins: Java, Haskell, R, Ocaml, fonts, SugarActivity, Ruby, PHP, C/C++, Perl
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Major Hayden 🤠 2021-05-24 12:50:02 UTC
Thank you, Ben. 🤗

It's been a little while since I submitted a new package for Fedora and I have now discovered that `fedora-review` tool. I'll work through the rofimoji changes and take a look at packaging wtype.

Comment 4 Major Hayden 🤠 2021-05-24 15:00:08 UTC
Ben: My wtype package is proposed over here:

  https://bugzilla.redhat.com/show_bug.cgi?id=1964027

Comment 5 Ben Beasley 2021-05-24 15:01:05 UTC
Thanks. I’ll review it.

Comment 6 Major Hayden 🤠 2021-05-26 21:45:01 UTC
Ben -- now that wtype is in rawhide and on its way to F34, does this spec need any more changes?

Thanks!

Comment 7 Ben Beasley 2021-05-27 15:57:36 UTC
Could you post an updated spec and SRPM incorporating the feedback from my original review? I don’t expect to have any new feedback.

Comment 8 Major Hayden 🤠 2021-05-27 19:17:35 UTC
Spec URL: https://fedorapeople.org/~mhayden/rofimoji.spec
SRPM URL: https://fedorapeople.org/~mhayden/rofimoji-5.1.0-4.fc34.src.rpm

I switched over to using pyproject-rpm-macros after a coworker recommended it. Here's the most recent koji build:

  https://koji.fedoraproject.org/koji/taskinfo?taskID=68875287

Comment 9 Ben Beasley 2021-05-29 13:16:41 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== Issues =====

- The base package is named as an application rather than a library (rofimoji
  rather than python-rofimoji), which I think is correct.

  Since this is an application, I think you should put everything in the base
  package and drop the python3-rofimoji subpackage. The subpackage doesn’t
  offer an importable package or module called “rofimoji” as you would expect
  by its name, and the package that is installed (“picker”) is clearly designed
  as the tool implementation rather than as an API.

  You could move the BuildRequires and Requires from python3-rofimoji into the
  base rofimoji package, change

    %files -n python3-%{srcname} -f %{pyproject_files}

  to

    %files -f %{pyproject_files}

  and drop the python3-rofimoji subpackage altogether.

  It wouldn’t hurt to add the following to the base package, then, although I
  am not convinced it is required because the package is only intended to be
  imported by the application:

    %py_provides python3-picker

- You can, if you like, move

    Version:        5.1.0

  back below

    Name:           %{srcname}

  and the expansion of

    %global         tag         %{version}

  will still work.

- You have placed

    %generate_buildrequires
    %pyproject_buildrequires -r

  as if it were part of %prep, but %generate_buildrequires is its own section.
  To make it less confusing, add a blank line before %generate_buildrequires.

  While there is no technical requirement to put %generate_buildrequires in a
  particular part of the spec file, a more common placement for this would be
  after the base package’s %description.

- This looks like it is left over from an experiment:

    echo "error" >&2

- The quotes here are unnecessary and unusal:

    %pyproject_save_files 'picker'

- I tried the package in an actual Wayland session on Fedora 34. I was unable
  to type into the filter field, and when I double-clicked an emoji, I got
  “Compositor does not support the virtual keyboard protocol” in the terminal.
  Does it work for you?

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License", "*No copyright* Expat
     License". 314 files have unknown license. Detailed output of
     licensecheck in /home/reviewer/1961783-rofimoji/re-
     review/1961783-rofimoji/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.

     Upstream provides no tests.

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: python3-rofimoji-5.1.0-4.fc35.noarch.rpm
          rofimoji-5.1.0-4.fc35.src.rpm
python3-rofimoji.noarch: W: spelling-error %description -l en_US emoji -> emotive
python3-rofimoji.noarch: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
python3-rofimoji.noarch: E: non-executable-script /usr/lib/python3.9/site-packages/picker/rofimoji.py 644 /usr/bin/env python3
rofimoji.src: W: spelling-error Summary(en_US) rofi -> profit
rofimoji.src: W: spelling-error %description -l en_US emoji -> emotive
rofimoji.src: W: spelling-error %description -l en_US rofi -> profit
rofimoji.src: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
rofimoji.src: W: spelling-error %description -l en_US wofi -> woof
2 packages and 0 specfiles checked; 1 errors, 7 warnings.




Rpmlint (installed packages)
----------------------------
python3-rofimoji.noarch: W: spelling-error %description -l en_US emoji -> emotive
python3-rofimoji.noarch: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
python3-rofimoji.noarch: E: non-executable-script /usr/lib/python3.9/site-packages/picker/rofimoji.py 644 /usr/bin/env python3
1 packages and 0 specfiles checked; 1 errors, 2 warnings.



Source checksums
----------------
https://github.com/fdw/rofimoji/archive/5.1.0/rofimoji-5.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : fba77f79c131f9423e0e92c22cd288c903f202ee46e8512740b732cc8df03f2d
  CHECKSUM(SHA256) upstream package : fba77f79c131f9423e0e92c22cd288c903f202ee46e8512740b732cc8df03f2d


Requires
--------
python3-rofimoji (rpmlib, GLIBC filtered):
    (python3.9dist(configargparse) < 2 with python3.9dist(configargparse) > 0.15)
    /usr/bin/python3
    python(abi)
    rofi
    wl-clipboard
    wofi
    wtype
    xclip
    xdotool
    xsel



Provides
--------
python3-rofimoji:
    python-rofimoji
    python3-rofimoji
    python3.9-rofimoji
    python3.9dist(rofimoji)
    python3dist(rofimoji)



Diff spec file in url and in SRPM
---------------------------------
--- /home/reviewer/1961783-rofimoji/re-review/1961783-rofimoji/srpm/rofimoji.spec	2021-05-29 08:10:49.992386971 -0400
+++ /home/reviewer/1961783-rofimoji/re-review/1961783-rofimoji/srpm-unpacked/rofimoji.spec	2021-05-27 14:37:23.000000000 -0400
@@ -45,4 +45,5 @@
 %generate_buildrequires
 %pyproject_buildrequires -r
+echo "error" >&2
 
 %build


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 1961783
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Python, Generic
Disabled plugins: PHP, Ruby, Ocaml, Java, SugarActivity, C/C++, R, fonts, Perl, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 10 Major Hayden 🤠 2021-06-01 14:16:02 UTC
> - The base package is named as an application rather than a library (rofimoji
>   rather than python-rofimoji), which I think is correct.
> 
>   Since this is an application, I think you should put everything in the base
>   package and drop the python3-rofimoji subpackage. The subpackage doesn’t
>   offer an importable package or module called “rofimoji” as you would expect
>   by its name, and the package that is installed (“picker”) is clearly
> designed
>   as the tool implementation rather than as an API.
> 
>   You could move the BuildRequires and Requires from python3-rofimoji into
> the
>   base rofimoji package, change
> 
>     %files -n python3-%{srcname} -f %{pyproject_files}
> 
>   to
> 
>     %files -f %{pyproject_files}
> 
>   and drop the python3-rofimoji subpackage altogether.
> 
>   It wouldn’t hurt to add the following to the base package, then, although I
>   am not convinced it is required because the package is only intended to be
>   imported by the application:
> 
>     %py_provides python3-picker

That makes sense. It's now fixed.

> - You can, if you like, move
> 
>     Version:        5.1.0
> 
>   back below
> 
>     Name:           %{srcname}
> 
>   and the expansion of
> 
>     %global         tag         %{version}
> 
>   will still work.

Done!

> - You have placed
> 
>     %%generate_buildrequires
%pyproject_buildrequires -r
>     %pyproject_buildrequires -r
> 
>   as if it were part of %prep, but %generate_buildrequires is its own
> section.
>   To make it less confusing, add a blank line before %generate_buildrequires.
> 
>   While there is no technical requirement to put %generate_buildrequires in a
>   particular part of the spec file, a more common placement for this would be
>   after the base package’s %description.

Fixed. I wasn't aware that '%generate_buildrequires' was its own section until you mentioned it!

> - This looks like it is left over from an experiment:
> 
>     echo "error" >&2

🤭 That was a mistake, indeed.

> - The quotes here are unnecessary and unusal:
> 
>     %pyproject_save_files 'picker'

Fixed.

> - I tried the package in an actual Wayland session on Fedora 34. I was unable
>   to type into the filter field, and when I double-clicked an emoji, I got
>   “Compositor does not support the virtual keyboard protocol” in the
> terminal.
>   Does it work for you?

This does work for me if I install 'wtype'. I tested in Sway (Wayland) yesterday and it seems to work properly. Which WM are you using? I can try it there.

I'll post the spec + SRPM shortly.

Comment 12 Major Hayden 🤠 2021-06-01 15:19:42 UTC
Ugh, the shebang fix was not what I thought it was. Correcting that now and running it through COPR. https://copr.fedorainfracloud.org/coprs/mhayden/rofimoji/build/2221246/

Comment 14 Ben Beasley 2021-06-01 20:12:32 UTC
> This does work for me if I install 'wtype'. I tested in Sway (Wayland) yesterday and it seems to work properly. Which WM are you using? I can try it there.

I’m using standard GNOME/Wayland on Fedora 34. It doesn’t have to work for me for the package review to be approved (it should probably work for SOMEONE), but I’m happy to help debug.

I’ll review the updated submission ASAP.

Comment 15 Major Hayden 🤠 2021-06-01 20:21:12 UTC
Thanks for letting me know what you're using. I'll put it into a VM with GNOME/Wayland and give it a try.

Comment 16 Ben Beasley 2021-06-02 15:31:45 UTC
This looks fine now. It still doesn’t work for me, as I previously described, but it seems to be correctly packaged.

Please feel free to ask me to help debug, here or in a new issue filed against the package post-import.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License", "*No copyright* Expat
     License". 314 files have unknown license. Detailed output of
     licensecheck in /home/reviewer/1961783-rofimoji/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.

     GUI is intended to be launched from the command line only.

[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.

     Submitter reports it works for them.

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.

     Upstream does not provide tests.

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rofimoji-5.1.0-5.fc35.noarch.rpm
          rofimoji-5.1.0-5.fc35.src.rpm
rofimoji.noarch: W: spelling-error %description -l en_US emoji -> emotive
rofimoji.noarch: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
rofimoji.src: W: spelling-error Summary(en_US) rofi -> profit
rofimoji.src: W: spelling-error %description -l en_US emoji -> emotive
rofimoji.src: W: spelling-error %description -l en_US rofi -> profit
rofimoji.src: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
rofimoji.src: W: spelling-error %description -l en_US wofi -> woof
2 packages and 0 specfiles checked; 0 errors, 7 warnings.




Rpmlint (installed packages)
----------------------------
rofimoji.noarch: W: spelling-error %description -l en_US emoji -> emotive
rofimoji.noarch: W: spelling-error %description -l en_US dmenu -> menu, d menu, madmen
1 packages and 0 specfiles checked; 0 errors, 2 warnings.



Source checksums
----------------
https://github.com/fdw/rofimoji/archive/5.1.0/rofimoji-5.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : fba77f79c131f9423e0e92c22cd288c903f202ee46e8512740b732cc8df03f2d
  CHECKSUM(SHA256) upstream package : fba77f79c131f9423e0e92c22cd288c903f202ee46e8512740b732cc8df03f2d


Requires
--------
rofimoji (rpmlib, GLIBC filtered):
    (python3.9dist(configargparse) < 2 with python3.9dist(configargparse) > 0.15)
    /usr/bin/python3
    python(abi)
    rofi
    wl-clipboard
    wofi
    wtype
    xclip
    xdotool
    xsel



Provides
--------
rofimoji:
    python-picker
    python3-picker
    python3.9-picker
    python3.9dist(rofimoji)
    python3dist(rofimoji)
    rofimoji



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 1961783
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Python
Disabled plugins: fonts, SugarActivity, PHP, Java, R, Perl, C/C++, Ruby, Haskell, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 17 Major Hayden 🤠 2021-06-02 18:17:45 UTC
I think I figured it out, Ben. It looks like rofimoji defaults to most of the X11 type defaults, but you can override them. I set up a custom keyboard shortcut in GNOME/Wayland to run:

rofimoji --selector wofi --action print

It likes to run rofi by default, but this causes it to run wofi instead. Perhaps rofimoji should be a bit smarter to detect which system is running.

Comment 18 Major Hayden 🤠 2021-06-02 18:19:06 UTC
(In reply to Major Hayden from comment #17)
> I think I figured it out, Ben. It looks like rofimoji defaults to most of
> the X11 type defaults, but you can override them. I set up a custom keyboard
> shortcut in GNOME/Wayland to run:
> 
> rofimoji --selector wofi --action print
> 
> It likes to run rofi by default, but this causes it to run wofi instead.
> Perhaps rofimoji should be a bit smarter to detect which system is running.

To be fair, each window manager takes a little work to figure out with rofimoji. When I went from GNOME+X11 to i3wm+X11, I had to change how I ran rofimoji. I had to change again when switching to sway/Wayland.

Comment 19 Ben Beasley 2021-06-02 18:24:36 UTC
> rofimoji --selector wofi --action print

Thanks. I can confirm that works just fine (and uses a very different widget style).

Comment 20 Gwyn Ciesla 2021-06-02 19:18:12 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/rofimoji

Comment 21 Fedora Update System 2021-06-02 19:48:50 UTC
FEDORA-2021-86c956b384 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-86c956b384

Comment 22 Fedora Update System 2021-06-02 19:48:51 UTC
FEDORA-2021-31c566a3df has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-31c566a3df

Comment 23 Fedora Update System 2021-06-03 01:31:01 UTC
FEDORA-2021-31c566a3df has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-31c566a3df \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-31c566a3df

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 24 Fedora Update System 2021-06-03 19:05:05 UTC
FEDORA-2021-86c956b384 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-86c956b384 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-86c956b384

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 25 Fedora Update System 2021-06-11 01:14:04 UTC
FEDORA-2021-86c956b384 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 26 Fedora Update System 2021-06-11 01:19:49 UTC
FEDORA-2021-31c566a3df has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.